require_relative "types"

class Env
  attr_reader :data
  def initialize(outer=nil, binds=[], exprs=[])
    @outer = outer
    @data = {}
    for i in 0..binds.length
      if binds[i] == :&
        @data[binds[i+1]] = List.new exprs.drop i
        break
      end
      @data[binds[i]] = exprs[i]
    end
  end

  def set(key, val)
    @data[key] = val
  end

  def find(key)
    if @data.key? key
      return self
    else
      if @outer
        return @outer.find(key) 
      else 
        return nil 
      end
    end
  end

  def get(key)
    env = self.find key
    if env
      env.data[key]
    else 
      raise "'" + key.to_s + "' not found" 
    end
  end
end
