require_relative "types"

def pr_str(exp, print_readably=true)
  return case exp
  when List
    output = "("
    exp.each do |exp|
      output += pr_str(exp) + " "
    end
    if output == "(" then return "()" end
    output[0..-2] + ")"
  when Vector
    output = "["
    exp.each do |exp|
      output += pr_str(exp) + " "
    end
    if output == "[" then return "[]" end
    output[0..-2] + "]"
  when Hash
    output = "{"
    exp.to_a.each do |key, value|
      output += pr_str(key) + " " + pr_str(value) + " "
    end
    if output == "{" then return "{}" end
    output[0..-2] + "}"
  when String
    if exp[0] == "\u029e"
      return ":" + exp[1..-1]
    end
    if print_readably
      return exp.inspect
    else 
      return exp
    end
  when Atom
    "(atom " + exp.val.to_s + ")"
  when nil
    "nil"
  else
    exp.to_s
  end
end
