require_relative "printer"

class Vector < Array
end

class List < Array
end

class Fun
  attr_accessor :ast
  attr_accessor :params
  attr_accessor :env
  attr_accessor :fn
  attr_accessor :is_macro
  def initialize(ast, params, env, fn, is_macro=false)
    @ast = ast
    @params = params
    @env = env
    @fn = fn
    @is_macro = is_macro
  end
end

class Atom
  attr_accessor :val
  def initialize(val)
    @val = val
  end
end

class Comment end

class MalException < Exception
  attr_accessor :mal_value
  def initialize(mal_value)
    super(pr_str(mal_value))
    @mal_value = mal_value
  end
end
